'use strict'

var join = require('path').join;

/**
 * utility functions
 */

var _hexChars = '0123456789abcdef'.split('');

var _generateRandomHex = function(length) {
    var hexVal = '';
    for (var i = 0; i < length; i++) {
        hexVal += _hexChars[Math.floor(Math.random() * _hexChars.length)];
    }
    return hexVal;
};

var _getAbsolutePath = function(path) {
    var res = null,
        homeDir = process.env.HOME || process.env.USERPROFILE;
		
    var windowsRegex = /([A-Z|a-z]:\\[^*|"<>?\n]*)|(\\\\.*?\\.*)/;
		
    if (path.match(/^\//) || path.match(windowsRegex)) {
		//On Windows and linux
        res = path;
    } else {
        if (path === '~') {
			//On linux only
            res = homeDir;
        } else if (path.slice(0, 2) !== '~/') {
			//On Windows and linux
            res = join(process.cwd(), path);
        } else {
			//On linux only
            res = join(homeDir, path.slice(2));
        }
    }
    return res;
};

var _outputJSON = function(json, logger) {
    logger.log('info', typeof json === 'object' ?
        JSON.stringify(json, null, '\t') : json);
};

module.exports = {
    hexChars: _hexChars,
    generateRandomHex: _generateRandomHex,
    getAbsolutePath: _getAbsolutePath,
    outputJSON: _outputJSON
};
